#pragma once

#include "CoreMinimal.h"
#include "CoreSelectableButtonWidget.h"
#include "MysteryBoxClaimClickedDelegate.h"
#include "StoreMysteryBoxViewData.h"
#include "CoreStoreFeaturedMysteryBoxWidget.generated.h"

class UDBDTextBlock;
class UCoreButtonWidget;

UCLASS(Blueprintable, EditInlineNew)
class UCoreStoreFeaturedMysteryBoxWidget : public UCoreSelectableButtonWidget
{
	GENERATED_BODY()

public:
	UPROPERTY(BlueprintReadWrite, BlueprintAssignable)
	FMysteryBoxClaimClickedDelegate OnMysteryBoxClaimClicked;

protected:
	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDTextBlock* DescriptionTB;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FStoreMysteryBoxViewData _cachedViewData;

public:
	UFUNCTION(BlueprintCallable, BlueprintNativeEvent)
	void SetData(const FStoreMysteryBoxViewData& viewData);

private:
	UFUNCTION(BlueprintCallable)
	void OnClaimButtonClicked(UCoreButtonWidget* buttonTarget);

public:
	UFUNCTION(BlueprintPure)
	FStoreMysteryBoxViewData GetMysteryBoxViewData() const;

public:
	UCoreStoreFeaturedMysteryBoxWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreStoreFeaturedMysteryBoxWidget) { return 0; }
